/*******************************************************************************
 * Copyright (c) 2018 VRE4EIC Consortium
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/

package eu.sshoc.citation.service.services;



import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.List;
import java.util.Properties;

import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import eu.sshoc.citation.service.wfconfigurator.impl.CitationServiceImpl;
import io.swagger.annotations.ApiOperation;



/**
 *  
 * @author Cesare
 *
 */

@RestController
public class CitationService {

	Properties property = new Properties();
	CitationServiceImpl wfc= new CitationServiceImpl();
	public CitationService()  {
		super();
		
		/*InputStream in;
		
		try {
			in = this.getClass().getClassLoader()
					.getResourceAsStream("Settings.properties");
			property.load(in);
			in.close();
		} catch (FileNotFoundException e) {
			
		} catch (IOException e) {
			
		}*/
	}

	 @ApiOperation(value = "Returns a list of  citations", 
		        notes = "A client with a valid identifier can invoke this web service to obtain a list of citations", 
		        response = String.class)
	    @RequestMapping(value="/citservice/getcitation", method=RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	 public String getServiceDescriptions(@RequestParam(value="sshocid") String sshocid, @RequestParam(value="token") String token) {
		
		 return wfc.getServiceDescriptions(sshocid, token);
	 }
	    
	    @ApiOperation(value = "Search for citation (implementation in progress)", 
		        notes = "A client with a valid identifier can invoke this web service to search for citations", 
		        response = String.class)
	    @RequestMapping(value="/citservice/searchcitation", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
		public String searchServiceDescriptions(@RequestParam(value="sshocid") String sshocid, @RequestParam(value="query") String query, @RequestParam(value="token") String token){

			return null;
		}
	    
	    @ApiOperation(value = "Save a citation (implementation in progress)", 
		        notes = "A client with a valid identifier can invoke this web service to save the citation", 
		        response = String.class)
	    @RequestMapping(value="/citservice/savecitation", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
		public String saveCitations(@RequestParam(value="sshocid") String sshocid, @RequestParam(value="description") String description, @RequestParam(value="token") String token){

	    	
			 return wfc.saveCitations(sshocid, description, token);
		}
	    @ApiOperation(value = "Search for citations (implementation in progress)", 
		        notes = "A client with a valid identifier can invoke this web service to search the SSHOC repository for citations", 
		        response = String.class)
	    @RequestMapping(value="/citservice/searchcite", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
		public String searchWfDescriptions(@RequestParam(value="sshocid") String sshocid, @RequestParam(value="query") String query, @RequestParam(value="token") String token){

			return wfc.getCitations(sshocid, query, token);
		}
	    

}
